/////////////////////////Basic programming in Lite_C/////////////////////////

///////////Created by : Ren Pol aka Realspawn www.rp-interactive.nl/////////////////////


/////////////////////////////Big thank you to Dico-Malice and Arrovse see credit info/////////////////////////////////////



#define PRAGMA_PATH "3Dmodels"
#define PRAGMA_PATH "Graphics"
#define PRAGMA_PATH "Sounds"


/////////////////////////////pointer sid model variables and sounds used/////////////////////////////////////


ENTITY* sid;

var enable_gamestart =1;
var score = 0;
var soundtrack_handle;

SOUND* coin_snd = "coin.wav";

SOUND* door_snd = "door.wav";
SOUND* teleport_snd = "teleport.wav";



/////////////////////////////fire creation particle/////////////////////////////////////


BMAP* fire_tga = "fire.tga"; 


function fade_fire(PARTICLE *p)
{
	p.alpha -= 4 * time_step;
	if (p.alpha < 0) 
	p.lifespan = 0;
}



function fire_effect(PARTICLE *p)
{
	p->vel_x = 4 - random(8); 
	p->vel_y = 4 - random(8); 
	p->vel_z = 2 + random(5); 
	p.alpha = 20 + random(30); 
	p.bmap = fire_tga;
	p.size = 45; 
	p.flags |= (BRIGHT | MOVE);
	p.event = fade_fire; 
} 




/////////////////////////////enemy ball trail particle/////////////////////////////////////



function my_p_event(PARTICLE*p)
{
	p.alpha -= p.skill_a*time_step;
	if(p.alpha <=0)p.lifespan =0;
	if(p.lifespan <25 && p.lifespan >15)
	p.green-=26.5*time_step;
	
}

function my_particle(PARTICLE* p)
{
	p.red = 255;
	p.blue =0;
	p.green =165;
	set(p, MOVE | BRIGHT | TRANSLUCENT);
	p.alpha = 100;
	p.size = 10;
	p.lifespan = 10;
	p.gravity = 0.06;
	p.skill_a = 2;
	p.event = my_p_event;
	
}


/////////////////////////////sprite animation functions/////////////////////////////////////



function sprite_played()
{

	set (my, PASSABLE |TRANSLUCENT);
	my.scale_x = 1; 
	my.scale_y = my.scale_x; 
	my.ambient = 100;
	my.roll = random(360); 
	my.alpha = 100; 
	while (my.frame < 8) 
	{	
		my.frame += 1 * time_step; 
		wait (1);
	}
	while (my.alpha > 0) 
	{
		my.alpha -= 4 * time_step; 
		wait (1);
	}
	
	ent_remove (me);
}

function sprite_played2()
{

	set (my, PASSABLE |TRANSLUCENT);
	my.scale_x = 1; 
	my.scale_y = my.scale_x; 
	my.ambient = 100;
	my.roll = random(360); 
	my.alpha = 100; 
	while (my.frame < 16) 
	{	
		my.frame += 1 * time_step; 
		wait (1);
	}
	while (my.alpha > 0) 
	{
		my.alpha -= 4 * time_step; 
		wait (1);
	}
	
	ent_remove (me);
}


/////////////////////////////set skycube/////////////////////////////////////


ENTITY* sky = 
{
	type = "skysunset+6.tga"; 
	flags2 = SKY | CUBE | SHOW;



}


/////////////////////////////countdown timer/////////////////////////////////////



var countdown_timer = 100; // this timer will run for 100 seconds
FONT* arial_font = "Arial#48b";
PANEL* timer_pan =
{
	layer = 15;
	digits(900, 700, 4 ,arial_font, 1, countdown_timer);
	flags = SHOW;
}
function countdown()
{
	while (1)
	{
		countdown_timer -= time_step / 16;
		countdown_timer = maxv(countdown_timer, 0); // don't allow the timer to go below zero
		if (countdown_timer <= 10) // counting down the last 10 seconds? Then let's make the digit red!
		vec_set(timer_pan.blue, vector(0, 0, 255)); // setting the blue, green, red vector color components
		wait (1);
	}
}



/////////////////////////////variables for  score/lives/stage/keys/////////////////////////////////////

var spells = 10;

FONT*	fnt1_pan = "Ariel#22b"; 
PANEL* pan_spells = {digits=10,50,"Spells: %00.0f",fnt1_pan,1,spells; 
	layer = 1;
	flags = SHOW;green=255; blue=0; red=255;
}


FONT*	fnt1_pan = "Ariel#22b"; 
PANEL* pan_score = {digits=10,5,"Score: %00.0f",fnt1_pan,1,score; 
	layer = 1;
	flags = SHOW;green=255; blue=0; red=255;
}

var lives = 3;

FONT*	fnt1_pan = "Ariel#22b"; 
PANEL* pan_lives = {digits=300,5,"Lives: %00.0f",fnt1_pan,1,lives; 

}

var stage = 1;

FONT*	fnt1_pan = "Ariel#22b"; 
PANEL* pan_stage = {digits=300,50,"Stage: %00.0f",fnt1_pan,1,stage; 
	layer = 1;
	flags = SHOW;green=255; blue=0; red=255;
}


var keys = 0;

FONT*	fnt1_pan = "Ariel#22b"; 
PANEL* pan_keys = {digits=300,5,"Keys: %00.0f",fnt1_pan,1,keys; 
	layer = 1;
	flags = SHOW;green=255; blue=0; red=255;
}



/////////////////////////////graphic and panels used/////////////////////////////////////

BMAP* gameover_map = "gameover.png"; 

PANEL* gameover_pan =
{
	bmap = gameover_map; 
	pos_x = 370;
	pos_y = 300;
	layer = 1;
}

BMAP* next_map = "next.png"; 

PANEL* next_pan =
{
	bmap = next_map; 
	pos_x = 400;
	pos_y = 300;
	layer = 1;
	////	flags = SHOW;
}



BMAP* lives01_map = "lives.png"; 

PANEL* lives01_pan =
{
	bmap = lives01_map; 
	pos_x = 800;
	pos_y = 10;
	layer = 1;
	flags = SHOW;
}


BMAP* lives02_map = "lives.png"; 

PANEL* lives02_pan =
{
	bmap = lives02_map; 
	pos_x = 870;
	pos_y = 10;
	layer = 1;
	flags = SHOW;
}

BMAP* lives03_map = "lives.png"; 

PANEL* lives03_pan =
{
	bmap = lives03_map; 
	pos_x = 940;
	pos_y = 10;
	layer = 1;
	flags = SHOW;
}

/////////////////////////////restart game function/////////////////////////////////////

function begin_game()
{

	if(enable_gamestart ==0){
		countdown_timer = 100;
		reset(gameover_pan,SHOW);
		level_load("justagame.WMB");
		enable_gamestart =1;
		score =0;
		lives =3;
		keys = 0;
		set(lives01_pan,SHOW);
		set(lives02_pan,SHOW);
		set(lives03_pan,SHOW);
		set(timer_pan,SHOW);

		wait(1);	

	}
}


/////////////////////////////fire and use magic balls/////////////////////////////////////

function ball_impact() 
{
	
	set(my,PASSABLE|INVISIBLE); 
	my.event = NULL;
	ent_create("Explosion+16.tga", vector(my.x,my.y,my.z), sprite_played2);
	wait(1);
	ent_remove(me); 
}



action magic_ball()
{
	set(my,PASSABLE);	
	my.emask |= (ENABLE_IMPACT | ENABLE_BLOCK | ENABLE_ENTITY);  
	my.event = ball_impact; 
	my.pan = sid.pan;
	my.skill100 = 100;
	while(1)
	{
		
		c_move(me, vector(65 * time_step, 0, 0), nullvector, IGNORE_ME | IGNORE_SPRITES); 
		wait(1);
		if(vec_dist(my.x,sid.x) >40){
			reset(my,PASSABLE);
		}
	}
}

function magic_spell()
{
	if(spells >=1){
		
		ent_create("ball2.mdl", vector(sid.x,sid.y,sid.z), magic_ball);
		spells -=1;
	}
}


/////////////////////////////the main function/////////////////////////////////////


function main()
{
	video_set(1024,768,32,0);
	soundtrack_handle = media_loop("ingame.wav", NULL, 80);
	level_load("justagame.WMB");
	on_space = begin_game;
	countdown();
}

/////////////////////////////Player movement and hit/hurt sid model/////////////////////////////////////

action player_movement();

action hurt_sid();
function hit_byball()
{
	if(you.skill1 != 1)
	{
		ent_create("magic22+8.png", vector(my.x,my.y,my.z), sprite_played);
		set(my,PASSABLE | INVISIBLE);
		my.event = NULL;
		

		
		lives -=1;
		if(lives ==2){
			reset(lives03_pan,SHOW);
		}
		if(lives ==1){
			reset(lives02_pan,SHOW);
		}
		if(lives ==0){
			reset(lives01_pan,SHOW);
		}
		wait(-1);

		if(lives >=1){
			if(stage ==1){
				
				ent_create("Sid.mdl", vector(0,0,48), player_movement);
				ent_create("hurtcoin.mdl", vector(my.x,my.y,my.z),hurt_sid);
				ent_remove(me);
			}
			if(stage ==2)
			ent_create("Sid.mdl", vector(1397,-4,377), player_movement);
		}
		else
		{
			
			set(gameover_pan,SHOW);
			enable_gamestart =0;
			reset(timer_pan,SHOW);
			
		}		
	}

}
var is_input_pressed()
{
	if(key_cul != 0 || key_cuu != 0 || key_cur != 0 || key_cud != 0)
	{
		return 1;
	}
	return 0;
}


//Allows to rotate player
function movement_input(ENTITY* my)
{
	if(is_input_pressed())
	{
		var side_direction = 0;
		var up_direction = 0;
		if(key_cul){side_direction = 1;}
		if(key_cur){side_direction = 2;}
		if(key_cuu){up_direction = 1;}
		if(key_cud){up_direction = 2;}
		//finalizing angles
		//horizontal movement
		if(up_direction == 0)
		{
			if(side_direction == 1)
			{
				my.pan = 90;
			}
			if(side_direction == 2)
			{
				my.pan = 270;
			}
		}
		//vertical movement
		if(side_direction == 0)
		{
			if(up_direction == 1)
			{
				my.pan = 0;
			}
			if(up_direction == 2)
			{
				my.pan = 180;
			}
		}
		//diagonal movement
		if(up_direction != 0 && side_direction != 0)
		{
			if(side_direction == 1 && up_direction == 1)
			{
				my.pan = 45;
			}
			if(side_direction == 2 && up_direction == 1)
			{
				my.pan = 315;
			}
			if(side_direction == 1 && up_direction == 2)
			{
				my.pan = 135;
			}
			if(side_direction == 2 && up_direction == 2)
			{
				my.pan = 225;
			}
		}
	}
}

action player_movement()
{
	my.skill100 =200;
	c_setminmax(my);
	set(my,SHADOW);
	sid = me;
	ANGLE temp_angles; // make this a local ANGLE if you use several identical entities
	my.skill20 =0; //SCAN RESULT FOR GRAVITY
	my.skill21=0;  // GRAVITY SPEED
	var run_percentage = 0;
	var stand_percentage = 0;
	my.emask |= (ENABLE_IMPACT); // the object is sensitive to block and entity collisions
	my.event = hit_byball;
	ent_create("magic22+8.png", vector(my.x,my.y,my.z), sprite_played);
	on_ctrl =magic_spell;

	while(1)
	{
		movement_input(my);

		my.skill20=c_trace(my.x, vector(my.x,my.y,my.z-500), IGNORE_ME);
		

		temp_angles.tilt = 0;
		temp_angles.roll = 0;
		temp_angles.pan = -my.pan;
		vec_rotate(normal, temp_angles);
		temp_angles.tilt = -asin(normal.x);
		temp_angles.roll = -asin(normal.y);
		my.tilt += 0.1 * ang(temp_angles.tilt - my.tilt); // play with 0.1 - it sets the angle adjusting speed
		my.roll += 0.1 * ang(temp_angles.roll - my.roll); // play with 0.1 - it sets the angle adjusting speed
		
		if(my.skill20 >60) //CHANGED THIS TO 60
		my.skill21=-50*time_step;
		else
		my.skill21=0;
		result = c_move(me, nullvector, vector(15 * (key_cuu - key_cud) * time_step, 15 * (key_cul - key_cur) * time_step,my.skill21), GLIDE | IGNORE_PASSABLE | IGNORE_SPRITES | ENABLE_BLOCK);
		if(result > 0)
		{
			run_percentage %= 100;
			run_percentage += 15 * time_step;
			ent_animate(my, "run", run_percentage, ANM_CYCLE);
		}
		else{
			stand_percentage %= 100;
			stand_percentage += 5 * time_step;
			ent_animate(my, "stand", stand_percentage, ANM_CYCLE);
		}
		wait(1);

		camera.tilt = -25; 
		camera.x = sid.x-800; 
		camera.y = sid.y; 
		camera.z = sid.z + 450; 
		
	}
}

/////////////////////////////coins / hurt coins /////////////////////////////////////


action coins()
{
	set(my,PASSABLE | SHADOW | METAL | BRIGHT);
	c_setminmax(my);
	while(vec_dist(my.x,sid.x) >20)
	{
		my.roll -= 4* time_step;
		my.tilt += 4* time_step;
		my.ambient = 200;
		my.lightrange = 20;
		wait(1);
	}
	snd_play(coin_snd, 100, 0);
	score +=10;	
	ent_remove(me);	
}

action hurt_sid()
{
	set(my,PASSABLE | SHADOW | METAL | BRIGHT);
	c_setminmax(my);
	while(vec_dist(my.x,sid.x) >20)
	{
		my.roll -= 4* time_step;
		my.tilt += 4* time_step;
		
		wait(1);
	}
	ent_create("magic22+8.png", vector(sid.x,sid.y,sid.z), sprite_played);
	snd_play(coin_snd, 100, 0);
	set(my,INVISIBLE|PASSABLE);
	ent_remove(sid);
	lives -=1;
	if(lives ==2){
		reset(lives03_pan,SHOW);
	}
	if(lives ==1){
		reset(lives02_pan,SHOW);
	}
	if(lives ==0){
		reset(lives01_pan,SHOW);
	}
	wait(-1);	
	if(lives >=1){
		if(stage ==1){
			
			ent_create("Sid.mdl", vector(0,0,48), player_movement);
			ent_create("hurtcoin.mdl", vector(my.x,my.y,my.z),hurt_sid);
			ent_remove(me);
		}
		if(stage ==2)
		ent_create("Sid.mdl", vector(1397,-4,377), player_movement);
	}

	else
	{
		
		set(gameover_pan,SHOW);
		enable_gamestart =0;
		reset(timer_pan,SHOW);
	}
}

/////////////////////////////sliding door////////////////////////////////////

action doorslide_left()
{


	set(my,METAL | SHADOW);
	c_setminmax(me);
	var init_x;
	init_x = my.x;
	while (!sid) {wait (1);} 
	while (1)
	{
		while (vec_dist (sid.x, my.x) > 100) {wait (1);} 
		
		if(keys >=1){
			snd_play (door_snd, 100, 0);
			keys -=1;
			while (my.x > init_x -200) 
			{
				my.x -= 20 * time_step; 
				wait (1);
			}
		}
		snd_play (door_snd, 100, 0); 		
		while (vec_dist (sid.x, my.x) < 500) {wait (1);} 
		
		while (my.x < init_x) 
		
		{
			my.x += 20 * time_step;
			wait (1);
		}
		my.x = init_x;

		
	}
}

/////////////////////////////pickup keys/////////////////////////////////////

action pickup_keys()
{
	set(my,PASSABLE | SHADOW | METAL | BRIGHT);
	c_setminmax(my);
	while(vec_dist(my.x,sid.x) >100)
	{
		my.roll -= 4* time_step;
		my.tilt += 4* time_step;
		my.ambient = 200;
		my.lightrange = 20;
		wait(1);
	}
	
	keys +=1;	


	ent_remove(me);

}





////////////////////////teleporter//////////////////////////

ENTITY* beamer1;
ENTITY* beamer2;

function beam_me1()
{
	snd_play(teleport_snd, 100, 0);
	my.event = NULL; // don't trigger several events
	wait (1);
	set (beamer2, PASSABLE); // don't allow beamer2 to teleport the player back to beamer1

	vec_set(sid.x, beamer2.x);
	
	my.event = beam_me1;
}
action portal1() // attach this action to the first portal
{
	beamer1 = my;
	while (!sid) {wait (1);}
	my.emask |= (ENABLE_IMPACT | ENABLE_ENTITY);
	while (1)
	{
		my.pan +=5*time_step;	
		if (vec_dist(sid.x, my.x) < 10) // the player was just beamed here?
		{
			set (my, PASSABLE);
			my.event = NULL; // then don't allow this beamer to teleport it back
			// wait until the player has moved away from this beamer
			while (vec_dist (my.x, sid.x) < 300) {wait (1);}
		}
		else
		{
			
			reset (my, PASSABLE);
			my.event = beam_me1;
		}
		wait (1);
	}
}
function beam_me2()
{
	snd_play(teleport_snd, 100, 0);
	my.event = NULL; // don't trigger several events
	wait (1);
	set (beamer1, PASSABLE); // don't allow beamer1 to teleport the player back to beamer2
	vec_set(sid.x, beamer1.x);
	my.event = beam_me2;
}
action portal2() // attach this action to the second portal
{
	beamer2 = my;
	while (!sid) {wait (1);}
	my.emask |= (ENABLE_IMPACT | ENABLE_ENTITY);
	while (1)
	{
		my.pan +=5*time_step;
		if (vec_dist(sid.x, my.x) < 10) // the player was just beamed here?
		{
			set (my, PASSABLE);
			my.event = NULL; // then don't allow this beamer to teleport it back
			// wait until the player has moved away from this beamer
			while (vec_dist (my.x, sid.x) < 300) {wait (1);}
		}
		else
		{
			reset (my, PASSABLE);
			my.event = beam_me2;
		}
		wait (1);
	}
}

////////////////////////////bouncing ball enemy////////////////////////////////



function bounce_off() // ball's event function
{
	vec_to_angle(my.pan, bounce); // change the direction as expected from a "real" ball
	my.pan += 5 - random(10); // add some randomness at each collision (don't allow the ball to get stuck)
	my.tilt = 0;


	
	


}

action my_enemyball() // attach this action to your ball
{
	my.emask |= (ENABLE_BLOCK | ENABLE_ENTITY); // the object is sensitive to block and entity collisions
	my.event = bounce_off;
	VECTOR vec_temp;
	while(1)
	{
		vec_set(vec_temp,vector(0,random(5)-2.5,0));
		vec_rotate(vec_temp,my.pan);
		effect(my_particle,1,my.x,vec_temp);
		c_move(me, vector(35 * time_step, 0, 0), nullvector, 0); // move ahead, in the direction given by the pan angle
		wait(1);
	}
}

/////////////////////////////exit and level change/////////////////////////////////////

action exit_level()
{

	set(my,PASSABLE | SHADOW | METAL | BRIGHT);
	c_setminmax(my);
	while(vec_dist(my.x,sid.x) >100)
	{
		
		my.pan += 14* time_step;
		my.ambient = 200;
		my.lightrange = 20;
		wait(1);
	}
	ent_remove(sid);

	stage +=1;
	proc_kill2(countdown,NULL);
	set(next_pan,SHOW);
	wait(-2);
	if(stage ==2){
		reset(next_pan,SHOW);
		score = score + countdown_timer;
		countdown_timer = 100;
		ent_remove(me);
		level_load("level002.WMB");
		countdown();
	}
}


/////////////////////////////create fire/////////////////////////////////////
action making_fire()
{
	set(my,INVISIBLE| PASSABLE);
	VECTOR temp;
	while(1)
	{
		effect(fire_effect,1,my.x,temp);
		my.pan +=5*time_step;
		wait(1);
	}
}


/////////////////////////elevator set skills in WED old elevator code////////////////////////////////////////////////////////////////////////////////////////////



#define elevator_height skill1
#define elevator_speed skill2
#define elevator_wait skill3
#define elevator_roaming skill4





function t_elevator_start();
function t_elevator_stop();


function elevator_waits()
{
	my.skill70 = 0;
	while (my.skill70 < my.elevator_wait)
	{
		my.skill70 += 50*time_step;
		wait (1);
	}	
	my.skill70 = 99;
}






// skill1: elevator_height 200
// skill2: elevator_speed 2
// skill3: elevator_wait 2
action elevator() 
{
	c_setminmax(me);
	set(my,SHADOW | METAL);
	var init_z = my.z ; 
	var waiting_time;
	var start_once = 0;
	var stop_once = 0;
	while (!sid) {wait (1);} 
	while(sid)
	{
		if (vec_dist (sid.x, my.x) < 100) 
		{
			if (my.z < my.elevator_height)
			{
				stop_once = 0;
				start_once += 1;
				if (start_once == 1)
				{
					
				}
				
				sid.z += my.elevator_speed * time_step; 
				my.z += my.elevator_speed * time_step;
			}
			else 
			{
				start_once = 0;
				stop_once += 1;
				if (stop_once == 1)
				{
					
				}					
				waiting_time = 0;
				while (waiting_time < my.elevator_wait)
				{
					waiting_time += time_step;
					wait (1);
				}
			}
		}
		else
		{
			start_once = 0;
			while (my.z > init_z) 
			{
				start_once += 1;
				if (start_once == 1)
				{
					
				}
				my.z -= my.elevator_speed * time_step; 
				if (vec_dist (sid.x, my.x) < 100) 
				{
					sid.z -= my.elevator_speed * time_step;
				}
				wait (1);
			}
			stop_once += 1;
			if (stop_once == 1)
			{
				
			}
			my.z = init_z; 
		}
		wait (1);
	}
}

/////////////////////////////////////////////////////////////////////////


/////////////////////////////exploding stuff/////////////////////////////////////

function explode_now()
{


	


	if(you.skill100 == my.skill100){

		set(my,PASSABLE|INVISIBLE); 
		my.event = NULL;
		ent_create("Explosion+16.tga", vector(my.x,my.y,my.z), sprite_played2);
		wait(-0.1);
		ent_create("Explosion+16.tga", vector(my.x,my.y,my.z), sprite_played2);
		wait(1);
		ent_remove(me);
	}
}

action exploding_stuff()
{
	set(my,SHADOW | METAL);
	my.skill100=100;
	my.emask |= (ENABLE_IMPACT);
	my.event = explode_now;
}

/////////////////////////////pickup magic potion/////////////////////////////////////

action pickup_magic()
{
	set(my,PASSABLE | SHADOW | METAL | BRIGHT);
	c_setminmax(my);
	while(vec_dist(my.x,sid.x) >100)
	{
		my.roll -= 4* time_step;
		my.tilt += 4* time_step;
		my.ambient = 200;
		my.lightrange = 20;
		wait(1);
	}
	spells +=10;
	ent_remove(me);

}

/////////////////////////////New and improved elevator /////////////////////////////////////
function add_force_to(ENTITY* ent)
{
	if(ent)
	{
		if(vec_dist(my.x,ent.x) < my.max_x * 2)
		{
			c_move(ent, nullvector, vector(0, 0,my.skill2), GLIDE | IGNORE_PASSABLE | IGNORE_SPRITES );
		}		
	}
}




action basic_elevator()
{
	var speed_elev = 5;
	var hight_elev = 200;
	var wait_time_in_second = 5;
	set(me,POLYGON);
	my.skill1 = 1;
	while(1)
	{
		var my_z = my.z + hight_elev;
		while(my.z < my_z)
		{
			my.skill2 = speed_elev * time_step;
			c_move(me, nullvector, vector(0, 0,my.skill2), GLIDE | IGNORE_PASSABLE | IGNORE_SPRITES );
			add_force_to(sid);
			wait(1);
		}
		wait(-wait_time_in_second);
		my_z = my.z - hight_elev;
		while(my.z > my_z)
		{
			my.skill2 = -speed_elev * time_step;
			c_move(me, nullvector, vector(0, 0,my.skill2), GLIDE | IGNORE_PASSABLE | IGNORE_SPRITES );
			add_force_to(sid);
			wait(1);
		}
		wait(-wait_time_in_second);
		wait(1);
	}
}
